#include<stdio.h>
#include<limits.h>
#include<float.h>

int equal(double a, double b, double tau, double epsilon);

int main() {
	int i=0;
	while(i+1>i) {i++;}
	printf("My biggest int by 'while' calculation: %i\n",i);
	i=0;
	for(int n=0;n+1>n;n++) {i++;}
	printf("My biggest int by 'for' calculation: %i\n",i);
	i=0;
	do{i++;}while(i+1>i);
	printf("My biggest int by 'do while' calculation: %i\n",i);
	printf("My biggest int by limit header: %i\n",INT_MAX);

	i=0;
	while(i-1<i) {i--;}
	printf("My lowest int by 'while' calculation: %i\n",i);
	i=0;
	for(int n=0;n-1<n;n++) {i--;}
	printf("My lowest int by 'for' calculation: %i\n",i);
	i=0;
	do{i--;}while(i-1<i);
	printf("My lowest int by 'do while' calculation: %i\n",i);
	printf("My lowest int by limit header: %i\n",INT_MIN);

	float x=1;
	while(1+x!=1){x/=2;} x*=2;
	printf("My float machine epsilon by 'while' calculation: %f\n",x);
	double y=1;
	while(1+y!=1){y/=2;} y*=2;
	printf("My double machine epsilon by 'while' calculation: %g\n",y);
	long double z=1;
	while(1+z!=1){z/=2;} z*=2;
	printf("My long double machine epsilon by 'while' calculation: %Lg\n",z);
	printf("My float machine epsilon by float header: %f\n",FLT_EPSILON);
	printf("My double machine epsilon by float header: %g\n",DBL_EPSILON);
	printf("My long double machine epsilon by float header: %Lg\n",LDBL_EPSILON);

	for(x=1;x+1!=1;x/=2){} x*=2;
	printf("My float machine epsilon by 'for' calculation: %f\n",x);
	for(y=1;y+1!=1;y/=2){} y*=2;
	printf("My double machine epsilon by 'for' calculation: %g\n",y);
	for(z=1;z+1!=1;z/=2){} z*=2;
	printf("My long double machine epsilon by 'while' calculation: %Lg\n",z);

	x=1;
	do{x/=2;}while(x+1!=1); x*=2;
	printf("My float machine epsilon by 'do while' calculation: %f\n",x);
	y=1;
	do{y/=2;}while(y+1!=1); y*=2;
	printf("My double machine epsilon by 'do while' calculation: %g\n",y);
	z=1;
	do{z/=2;}while(z+1!=1); z*=2;
	printf("My long double machine epsilon by 'do while' calculation: %Lg\n",z);

	int max = INT_MAX/2;
	float sum_up_float = 0;
	for(int i=1;i<=max;i++) {sum_up_float+=1.0f/i;}
	printf("Sum up float: %f\n",sum_up_float);
	float sum_down_float = 0;
	for(int i=max;i>=1;i--) {sum_down_float+=1.0f/i;}
	printf("Sum down float: %f\n",sum_down_float);
	double sum_up_double = 0;
	for(int i=1;i<=max;i++) {sum_up_double+=1.0/i;}
	printf("Sum up double: %g\n",sum_up_double);
	double sum_down_double = 0;
	for(int i=max;i>=1;i--) {sum_down_double+=1.0/i;}
	printf("Sum down double: %g\n",sum_down_double);

	int test = equal(1,2,2,2);
	printf("Equal funktionen fungerer %i\n",test);
}
