#include<stdio.h>
#include<math.h>
#include <gsl/gsl_integration.h>

double my_f(double x, void* params) {
	return log(x)/sqrt(x);
}

int main() {
	gsl_function F;
	F.function = &my_f;
	int limit = 9999;
	gsl_integration_workspace* w;
	w = gsl_integration_workspace_alloc (limit);
	double a=0,b=1,acc=1e-6,eps=1e-6,result,error;
	gsl_integration_qags(&F,a,b,acc,eps,limit,w,&result,&error);
	printf("Integralet giver: %g med fejl %g\n",result,error);
	gsl_integration_workspace_free(w);
return 0;
}