#include<math.h>
#include<complex.h>
#include<stdio.h>

int main() {
	double gam = tgamma(5);
	printf("Gamma function of 5 = %g\n",gam);

	double bes = j1(0.5);
	printf("Bessel function of 0.5 = %g\n",bes);

	double complex sqr = csqrt(-2);
	printf("Square root of -2 = %g + %gi\n",creal(sqr),cimag(sqr));

	double complex eipi = cpow(M_E,(I*M_PI));
	printf("e to the power i*pi = %g + %gi\n",creal(eipi),cimag(eipi));

	double complex ei = cpow(M_E,I);
	printf("e to the power i = %g + %gi\n",creal(ei),cimag(ei));

	double complex ie = cpow(I,M_E);
	printf("i to the power e = %g + %gi\n",creal(ie),cimag(ie));

	double complex ii = cpow(I,I);
	printf("i to the power i = %g + %gi\n",creal(ii),cimag(ii));

return 0;
}
