#include<stdio.h>
#include<math.h>
#include<gsl/gsl_sf_erf.h>
#include<gsl/gsl_sf_gamma.h>

double Erf(double);
double Gamma(double);

int main() {
	FILE* err_stream = fopen("err_data.txt","w");
	double xmin=-2,xmax=2;
	for(double x=xmin;x<=xmax;x+=1.0/8) {
		fprintf(err_stream,"%10g %10g %10g %10g\n",x,erf(x),gsl_sf_erf(x),Erf(x));
	}
	fclose(err_stream);
	
	FILE* gam_stream = fopen("gam_data.txt","w");
	double ymin=0.25,ymax=5;
	for(double y=ymin;y<=ymax;y+=1.0/32) {
		fprintf(gam_stream,"%10g %10g %10g %10g\n",y,tgamma(y),gsl_sf_gamma(y),Gamma(y));
	}
	fclose(gam_stream);
	
return 0;
}