#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include<math.h>
#include<time.h>
#include<stdio.h>
#include<assert.h>
#include<gsl/gsl_vector.h>
#include<gsl/gsl_matrix.h>
#include<gsl/gsl_blas.h>
#include<gsl/gsl_linalg.h>
#include<gsl/gsl_eigen.h>
#define RND (double)rand()/10000000

void print_vector(char s[], gsl_vector* v);
void print_matrix(gsl_matrix* M, FILE* stream);
void timesJ(gsl_matrix* A, int p, int q, double theta);
void Jtimes(gsl_matrix* A, int p, int q, double theta);
void jacobi_diag(gsl_matrix* A, gsl_matrix* V);
void timesJ_o(gsl_matrix* A, int p, int q, double theta);
void Jtimes_o(gsl_matrix* A, int p, int q, double theta);
void jacobi_diag_o(gsl_matrix* A, gsl_matrix* V);

#endif